.NET Core Goals and Priorities
==============================

Microsoft published .NET Core to GitHub, with the following goals and priorities.

Goals
-----

- Establish a high-quality open source .NET implementation, with [CoreCLR](https://github.com/dotnet/coreclr) and [CoreFX](https://github.com/dotnet/corefx).
- Port CoreCLR to Linux and OS X (already supported on Windows).
- Support the community extending CoreCLR in various ways (e.g. [FreeBSD support](https://github.com/dotnet/coreclr/issues/455)).

Priorities
----------

The project has the following priorities, set by the .NET Team:

- x64 is the priority chip to support. x86 and ARM32 will follow.
- Windows, Linux and OS X support have the same priority.
- Porting is a higher priority (at this time) than new features.

Microsoft Team Engagement
-------------------------

The Microsoft team will engage on incoming PRs and issues that align with these goals and priorities. The team will also try to engage on other issues as time allows.

The community is encouraged to create a broad range of issues. There may be a significant group of developers that are interested in the same topic. If a strong community viewpoint establishes itself on an issue outside of the core priority, then the team will likely engage on the issue. Engagement does not mean that the Microsoft team will necessarily build a feature, but discuss merits and implementation approaches.
