//
// Copyright (c) Microsoft. All rights reserved.
// Licensed under the MIT license. See LICENSE file in the project root for full license information. 
//

/*============================================================================
**
** Source:  test14.c
**
** Purpose: Tests _snprintf with exponential format doubles (lowercase)
**
**
**==========================================================================*/



#include <palsuite.h>
#include "../_snprintf.h"

/*
 * Notes: memcmp is used, as is strlen.
 */


int __cdecl main(int argc, char *argv[])
{
    double val = 256.0;
    double neg = -256.0;
    
    if (PAL_Initialize(argc, argv) != 0)
    {
        return FAIL;
    }


    DoDoubleTest("foo %e", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %le", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %he", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %Le", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %I64e", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %14e", val,  "foo  2.560000e+002",
                 "foo   2.560000e+02");
    DoDoubleTest("foo %-14e", val,  "foo 2.560000e+002 ",
                 "foo 2.560000e+02  ");
    DoDoubleTest("foo %.1e", val,  "foo 2.6e+002",  "foo 2.6e+02");
    DoDoubleTest("foo %.8e", val,  "foo 2.56000000e+002",
                 "foo 2.56000000e+02");
    DoDoubleTest("foo %014e", val,  "foo 02.560000e+002",
                 "foo 002.560000e+02");
    DoDoubleTest("foo %#e", val,  "foo 2.560000e+002",  "foo 2.560000e+02");
    DoDoubleTest("foo %+e", val,  "foo +2.560000e+002",  "foo +2.560000e+02");
    DoDoubleTest("foo % e", val,  "foo  2.560000e+002",  "foo  2.560000e+02");
    DoDoubleTest("foo %+e", neg,  "foo -2.560000e+002",  "foo -2.560000e+02");
    DoDoubleTest("foo % e", neg,  "foo -2.560000e+002",  "foo -2.560000e+02");

    PAL_Terminate();
    return PASS;
}
