using System;
/// <summary>
/// Convert.ToUInt16(Int16)
/// </summary>
public class ConvertToUInt166
{
    public static int Main()
    {
        ConvertToUInt166 convertToUInt166 = new ConvertToUInt166();

        TestLibrary.TestFramework.BeginTestCase("ConvertToUInt166");
        if (convertToUInt166.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        TestLibrary.TestFramework.LogInformation("[Negative]");
        retVal = NegTest1() && retVal;
        return retVal;
    }
    #region PositiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Convert to UInt16 from int16 1");
        try
        {
            Int16 Int16Val = Int16.MaxValue;
            ushort ushortVal = Convert.ToUInt16(Int16Val);
            if (ushortVal != (ushort)Int16Val)
            {
                TestLibrary.TestFramework.LogError("001", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Convert to UInt16 from int16 2");
        try
        {
            Int16 Int16Val = (Int16)this.GetInt32(0, (int)Int16.MaxValue);
            ushort ushortVal = Convert.ToUInt16(Int16Val);
            if (ushortVal != (ushort)Int16Val)
            {
                TestLibrary.TestFramework.LogError("003", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region NegativeTest
    public bool NegTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("NegTest1: the int16 is less than UInt16 minValue");
        try
        {
            Int16 Int16Val = (Int16)(this.GetInt32(1, (int)Int16.MaxValue + 2) * (-1));
            ushort ushortVal = Convert.ToUInt16(Int16Val);
            TestLibrary.TestFramework.LogError("N001", "the int16 is less than UInt16 minValue but not throw exception");
            retVal = false;
        }
        catch (OverflowException) { }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("N002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region HelpMethod
    private Int32 GetInt32(Int32 minValue, Int32 maxValue)
    {
        try
        {
            if (minValue == maxValue)
            {
                return minValue;
            }
            if (minValue < maxValue)
            {
                return minValue + TestLibrary.Generator.GetInt32(-55) % (maxValue - minValue);
            }
        }
        catch
        {
            throw;
        }

        return minValue;
    }
    #endregion
}
