using System;
/// <summary>
/// Convert.ToUInt64(UInt32)
/// </summary>
public class ConvertToUInt645
{
    public static int Main()
    {
        ConvertToUInt645 convertToUInt645 = new ConvertToUInt645();

        TestLibrary.TestFramework.BeginTestCase("ConvertToUInt645");
        if (convertToUInt645.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        retVal = PosTest3() && retVal;
        return retVal;
    }
    #region PositiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Convert to UInt64 from UInt32 1");
        try
        {
            UInt32 UInt32Val = UInt32.MaxValue;
            ulong ulongVal = Convert.ToUInt64(UInt32Val);
            if (ulongVal != (ulong)UInt32Val)
            {
                TestLibrary.TestFramework.LogError("001", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Convert to UInt64 from UInt32 2");
        try
        {
            UInt32 UInt32Val = UInt32.MinValue;
            ulong ulongVal = Convert.ToUInt64(UInt32Val);
            if (ulongVal != (ulong)UInt32Val)
            {
                TestLibrary.TestFramework.LogError("003", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest3()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest3: Convert to UInt64 from UInt32 3");
        try
        {
            UInt32 UInt32Val = (UInt32)(this.GetInt32(0, Int32.MaxValue)) + (UInt32)(this.GetInt32(0, Int32.MaxValue));
            ulong ulongVal = Convert.ToUInt64(UInt32Val);
            if (ulongVal != (ulong)UInt32Val)
            {
                TestLibrary.TestFramework.LogError("005", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("006", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region HelpMethod
    private Int32 GetInt32(Int32 minValue, Int32 maxValue)
    {
        try
        {
            if (minValue == maxValue)
            {
                return minValue;
            }
            if (minValue < maxValue)
            {
                return minValue + TestLibrary.Generator.GetInt32(-55) % (maxValue - minValue);
            }
        }
        catch
        {
            throw;
        }

        return minValue;
    }
    #endregion
}
