using System;

/// <summary>
/// GetTotalMemory(System.Boolean)
/// </summary>
public class GCGetTotalMemory
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Call GetTotalMemory with forceFullCollection set to false");

        try
        {
            long result = GC.GetTotalMemory(false);

            if (result == 0)
            {
                TestLibrary.TestFramework.LogError("001.1", "Calling GetTotalMemory with forceFullCollection set to false returns 0");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001.0", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }

    public bool PosTest2()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest2: Call GetTotalMemory with forceFullCollection set to true");

        try
        {
            long result = GC.GetTotalMemory(true);

            if (result == 0)
            {
                TestLibrary.TestFramework.LogError("002.1", "Calling GetTotalMemory with forceFullCollection set to true returns 0");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002.0", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        GCGetTotalMemory test = new GCGetTotalMemory();

        TestLibrary.TestFramework.BeginTestCase("GCGetTotalMemory");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
