using System;

/// <summary>
/// NewGuid
/// </summary>
public class GuidNewGuid
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Call NewGuid to create a new Guid instance");

        try
        {
            Guid guid = Guid.NewGuid();

            if (guid.Equals(Guid.Empty))
            {
                TestLibrary.TestFramework.LogError("001.1", "Call NewGuid to create a new Guid instance returns Guid.Empty");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001.0", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        GuidNewGuid test = new GuidNewGuid();

        TestLibrary.TestFramework.BeginTestCase("GuidNewGuid");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
