using System;

public class Int32GetHashCode
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: check that if the return value is equal to the int32 ");

        try
        {
            Int32 i1 = TestLibrary.Generator.GetInt32(-55);
            Int32 i2 = i1.GetHashCode();
            if (i1 != i2)
            {
                TestLibrary.TestFramework.LogError("001", "int32.gethashcode is not equal to the int32 itself : " + i1);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpected exception: " + e);
            retVal = false;
        }

        return retVal;
    }
    #endregion

    #endregion

    public static int Main()
    {
        Int32GetHashCode test = new Int32GetHashCode();

        TestLibrary.TestFramework.BeginTestCase("Int32GetHashCode");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
