using System;
using System.Collections.Generic;


/// <summary>
/// System.Math.E
/// </summary>
public class MathE
{
    public static int Main(string[] args)
    {
        MathE mathE = new MathE();
        TestLibrary.TestFramework.BeginTestCase("Testing System.Math.E...");

        if (mathE.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }

    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify the value of Math.E...");

        try
        {
            double constantE = Math.E;
            if (constantE != 2.7182818284590451)
            {
                TestLibrary.TestFramework.LogError("001","The value of E is not correct!");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002","Unexpected exception occurs: " + e);
            retVal = false;
        }

        return retVal;
    }
}
