using System;
using System.Reflection.Emit;

/// <summary>
/// Pushr4 [v-yishi]
/// </summary>
public class StackBehaviourPushr4
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify the value of Pushr4 is 23");

        try
        {
            int expected = 23;
            int actual = (int)StackBehaviour.Pushr4;

            if (expected != actual)
            {
                TestLibrary.TestFramework.LogError("001.1", "Pushr4's value is not 23");
                TestLibrary.TestFramework.LogInformation("WARNING [LOCAL VARIABLES] expected = " + expected + ", actual = " + actual);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        StackBehaviourPushr4 test = new StackBehaviourPushr4();

        TestLibrary.TestFramework.BeginTestCase("StackBehaviourPushr4");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 23;
        }
    }
}
