using System;
using System.Reflection.Emit;

/// <summary>
/// Varpush [v-yishi]
/// </summary>
public class StackBehaviourVarpush
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify the value of Varpush is 27");

        try
        {
            int expected = 27;
            int actual = (int)StackBehaviour.Varpush;

            if (expected != actual)
            {
                TestLibrary.TestFramework.LogError("001.1", "Varpush's value is not 27");
                TestLibrary.TestFramework.LogInformation("WARNING [LOCAL VARIABLES] expected = " + expected + ", actual = " + actual);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        StackBehaviourVarpush test = new StackBehaviourVarpush();

        TestLibrary.TestFramework.BeginTestCase("StackBehaviourVarpush");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 27;
        }
    }
}
