using System;
using System.Text;
/// <summary>
/// StringBuilder.Append(SByte)
/// </summary>
public class StringBuilderAppend14
{
    public static int Main()
    {
        StringBuilderAppend14 sbAppend14 = new StringBuilderAppend14();
        TestLibrary.TestFramework.BeginTestCase("StringBuilderAppend14");
        if (sbAppend14.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        retVal = PosTest3() && retVal;
        return retVal;
    }
    #region PositiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1:Invoke Append method in the initial StringBuilder 1");
        try
        {
            StringBuilder sb = new StringBuilder();
            sbyte sbVal1 = (sbyte)this.GetInt32(0, 128);
            sbyte sbVal2 = (sbyte)(this.GetInt32(1, 129) * (-1));
            sb = sb.Append(sbVal1);
            sb = sb.Append(sbVal2);
            if (sb.ToString() != sbVal1.ToString() + sbVal2.ToString())
            {
                TestLibrary.TestFramework.LogError("001", "The ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2:Invoke Append method in the initial StringBuilder 2");
        try
        {
            string strSource = "formytest";
            StringBuilder sb = new StringBuilder(strSource);
            sbyte sbVal1 = (sbyte)this.GetInt32(0, 128);
            sbyte sbVal2 = (sbyte)(this.GetInt32(1, 129) * (-1)); 
            sb = sb.Append(sbVal1);
            sb = sb.Append(sbVal2);
            if (sb.ToString() != strSource + sbVal1.ToString() + sbVal2.ToString())
            {
                TestLibrary.TestFramework.LogError("003", "The ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest3()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest3:Invoke Append method in the initial StringBuilder 3");
        try
        {
            string strSource = null;
            StringBuilder sb = new StringBuilder(strSource);
            sbyte sbVal1 = (sbyte)this.GetInt32(0, 128);
            sbyte sbVal2 = (sbyte)(this.GetInt32(1, 129) * (-1)); 
            sb = sb.Append(sbVal1);
            sb = sb.Append(sbVal2);
            if (sb.ToString() != sbVal1.ToString() + sbVal2.ToString())
            {
                TestLibrary.TestFramework.LogError("005", "The ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("006", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region HelpMethod
    private Int32 GetInt32(Int32 minValue, Int32 maxValue)
    {
        try
        {
            if (minValue == maxValue)
            {
                return minValue;
            }
            if (minValue < maxValue)
            {
                return minValue + TestLibrary.Generator.GetInt32(-55) % (maxValue - minValue);
            }
        }
        catch
        {
            throw;
        }

        return minValue;
    }
    #endregion
}
